-- module_ctv.lua: Cutscene TV [nclok1405]

CTV_SRTT = 1
CTV_SRIV = 2
CTV_SRGOOH = 3

-- Cutscene List
-- mission: Required Mission
-- id: Internal Cutscene ID (or a mission ID)
-- display_name: User-visible Cutscene Name
-- activity: Activity to watch. If this activity is exited, warp back the player to a TV.
-- play_mission: Start a mission, and when it ends, warp back the player to a TV.
-- play_mission_cancel_quickly: Start a mission, and when a cutscene plays then ends, abort it silently.
CTV_CUTSCENES = {
	[CTV_SRTT] = {
		{ mission = "m01", id = "01_IN", display_name = "When Good Heists Go Bad: Intro" },
		{ mission = "m02", id = "02_in", display_name = "I'm Free - Free Falling: Intro" },
		{ mission = "m02", id = "02_out", display_name = "I'm Free - Free Falling: Outro" },
		{ mission = "m03", id = "03_out", display_name = "We're Going to Need Guns: Outro" },
		{ mission = "m04", id = "m04", play_mission_cancel_quickly = true, display_name = "Steelport Here I Am: Intro" },
		{ mission = "m05", id = "05_IN", display_name = "Party Time: Intro" },
		{ mission = "m05", id = "05_out", display_name = "Party Time: Outro" },
		{ mission = "mm_p_01", id = "mm_p_01", play_mission_cancel_quickly = true, display_name = "Guardian Angel: Intro" },
		{ mission = "mm_p_03", id = "mm_p_03", play_mission_cancel_quickly = true, display_name = "Takeover the City: Intro" },
		{ mission = "mm_p_05", id = "genki", display_name = "Professor Genki: Intro" },
		{ mission = "mm_p_06", id = "mm_p_06", play_mission = true, display_name = "We've Only Just Begun" },
		{ mission = "sh01", id = "MS_SH01", display_name = "Hit the Powder Room: Intro" },
		{ mission = "m06", id = "06_in", display_name = "The Belgian Problem: Intro" },
		{ mission = "m06", id = "06_Mid", display_name = "The Belgian Problem: Oleg" },
		{ mission = "m06", id = "06_Out1", display_name = "The Belgian Problem: Detonate Bomb Outro" },
		{ mission = "m06", id = "06_Out2", display_name = "The Belgian Problem: Disarm Bomb Outro" },
		{ mission = "m07", id = "07_In", display_name = "Return to Steelport: Intro" },
		{ mission = "m07", id = "07_out", display_name = "Return to Steelport: Outro" },
		{ mission = "m08", id = "08_in", display_name = "Trojan Whores: Intro" },
		{ mission = "m08", id = "08_out", display_name = "Trojan Whores: Outro",
          zones_to_false = {"nuke1", "nuke2", "int_sh03", "int_sh03c"} },
		{ mission = "mm_z_01", id = "mm_z_01", activity = "_A_SN_NE_01", display_name = "Snatch: Intro (Activity)" },
		{ mission = "mm_z_04", id = "mm_z_04", play_mission = true, display_name = "Painting a Picture" },
		{ mission = "sh02", id = "MS_SH02", display_name = "Pimps Up, Hos Down: Intro" },
		{ mission = "m09", id = "09_in", display_name = "The Ho Boat: Intro" },
		{ mission = "m09", id = "09_out", display_name = "The Ho Boat: Outro",
          zones_to_false = {"3count1", "3count2", "int3cc"} },
		{ mission = "m10", id = "10_in", display_name = "Gang Bang: Intro" },
		{ mission = "m10", id = "10_Mid", display_name = "Gang Bang: Technically Legal" },
		{ mission = "m10", id = "10_Out", display_name = "Gang Bang: Outro" },
		{ mission = "m11", id = "11_in", display_name = "Convoy Decoy: Intro" },
		{ mission = "m11", id = "11_out", display_name = "Convoy Decoy: Outro" },
		{ mission = "m12", id = "12_In", display_name = "Nyte Blayde's Return: Intro" },
		{ mission = "m12", id = "12_Out", display_name = "Nyte Blayde's Return: Outro" },
		{ mission = "m13", id = "13_in", display_name = "STAG Party: Intro" },
		{ mission = "m13", id = "13_out", display_name = "STAG Party: Outro" },
		{ mission = "m14", id = "14_in", display_name = "Live! With Killbane: Intro" },
		{ mission = "m14", id = "14_out", display_name = "Live! With Killbane: Outro" },
		{ mission = "m15", id = "15_in", display_name = "Learning Computer: Intro" },
		{ mission = "m15", id = "15_Out", display_name = "Learning Computer: Outro" },
		{ mission = "mm_k_01", id = "mm_k_01", activity = "_A_TB_NW_01", display_name = "Cyber Blazing: Intro (Activity)" },
		{ mission = "mm_k_05", id = "mm_k_05", play_mission = true, display_name = "Phone Phreak" },
		{ mission = "sh03", id = "DK_SH01", display_name = "Stop all the Downloading: Intro" },
		{ mission = "m16", id = "16_IN", display_name = "http://deckers.die: Intro" },
		{ mission = "m16", id = "16_out", display_name = "http://deckers.die: Outro",
          zones_to_false = {"3count1", "3count2", "int3cc"} },
		{ mission = "mm_m16_5", id = "mm_m16_5", play_phonecall = true, display_name = "Stilwater Blues" },
		{ mission = "m17", id = "17_in", display_name = "My Name is Cyrus Temple: Intro" },
		{ mission = "m17", id = "17_mid", display_name = "My Name is Cyrus Temple: Landing" },
		{ mission = "m17", id = "17_out", display_name = "My Name is Cyrus Temple: Outro",
          zones_to_false = {"ThermInt1", "thermext1", "therm2", "therm3_dst"} },
		{ mission = "m18", id = "18_in", display_name = "Air Steelport: Intro" },
		{ mission = "m18", id = "18_out", display_name = "Air Steelport: Outro" },
		{ mission = "m19", id = "19_in", display_name = "Zombie Attack: Intro" },
		{ mission = "m19", id = "19_out", display_name = "Zombie Attack: Outro" },
		{ mission = "m20", id = "20_in", display_name = "A Remote Chance: Intro" },
		{ mission = "m20", id = "20_out", display_name = "A Remote Chance: Outro" },
		{ mission = "mm_a_01", id = "mm_a_01", activity = "_A_IF_SW01", display_name = "Insurance Fraud: Intro (Activity)" },
		{ mission = "mm_a_04", id = "mm_a_04", play_mission = true, display_name = "Face Your Fear" },
		{ mission = "sh04", id = "ld_sh01", display_name = "3 Count Beat Down: Intro",
          zones_to_false = {"3count1", "3count2", "int3cc"} },
		{ mission = "m21", id = "21_in", display_name = "Murderbrawl XXXI: Intro" },
		{ mission = "m21", id = "21_out", display_name = "Murderbrawl XXXI: Outro" },
		{ mission = "m22", id = "22_in", display_name = "Three Way: Intro" },
		{ mission = "m22", id = "22_choice", display_name = "Three Way: Choice" },
		{ mission = "m22", id = "22_out1", display_name = "Three Way: Killbane Outro" },
		{ mission = "m23", id = "23_in", display_name = "STAG Film: Intro" },
		{ mission = "m23", id = "23_out", display_name = "STAG Film: Outro" },
		{ mission = "m24", id = "22_out2", display_name = "Gangstas in Space: Intro" },
		{ mission = "m24", id = "24_Out", display_name = "Gangstas in Space: Outro" },
		{ mission = "mm_p_07", id = "mm_p_07", play_phonecall = true, display_name = "Pub Crawl" },
		{ mission = "mm_z_05", id = "mm_z_05", play_phonecall = true, display_name = "High Times" },
		{ mission = "mm_k_06", id = "mm_k_06", play_phonecall = true, display_name = "The Morning After" },
		{ mission = "mm_a_05", id = "mm_a_05", play_phonecall = true, display_name = "There is No Try" },

		{ mission = "m24", id = "test_pc_light", display_name = "UNUSED: test_pc_light" },
		{ mission = "m24", id = "test_vehicle_light", display_name = "UNUSED: test_vehicle_light" },
		{ mission = "m24", id = "Bob_CTE", display_name = "UNUSED: Bob_CTE" },
		{ mission = "m24", id = "MS_SH02_jumbo", display_name = "UNUSED: MS_SH02_jumbo" },

		{ mission = "dlc1_mm_01", id = "dlc1_gb_in", display_name = "Apocalypse Genki: Intro" },
		{ mission = "dlc1_mm_06", id = "dlc1_gb_out", display_name = "Genkibowl Closing Ceremony" },
		
		-- DLC2/3's progress resets after you complete the third mission, so only Mission 1 is needed to unlock outro.
		{ mission = "dlc2_m01", id = "dlc2_gis_intro", display_name = "Faster, More Intense!: Intro" },
		{ mission = "dlc2_m01", id = "DLC2_GIS_Outro", display_name = "That's Not in the Script!: Outro" },

		{ mission = "dlc3_m01", id = "dlc3_mm_in", display_name = "Weird Science: Intro" },
		{ mission = "dlc3_m01", id = "dlc3_mm_out", display_name = "Send in the Clones: Outro" },
	},
	[CTV_SRIV] = {
		{ mission = "m00", id = "00_in", display_name = "Zero Saints Thirty: Intro" },
		{ mission = "m01", id = "01_In", display_name = "The Saints Wing: Intro" },
		{ mission = "m01", id = "01_M_1", display_name = "The Saints Wing: Press Conference" },
		{ mission = "m01", id = "01_M_2", display_name = "The Saints Wing: Outro" },
		{ mission = "m02", id = "02_Out", display_name = "A Pleasant Day: Outro" },
		{ mission = "mm_1_2", id = "MM01_02_bink", display_name = "Bending the Rules: Intro" },
		{ mission = "mm_1_2", id = "TB_NW01_bink", display_name = "Blazin: Intro" },
		{ mission = "mm_1_3", id = "MM01_03_bink", display_name = "Hot and Cold: Intro" },
		{ mission = "m03", id = "03_M_3", display_name = "The Real World: Homie Arrival" },
		{ mission = "m03", id = "03_Out", display_name = "The Real World: Outro" },
		{ mission = "mm_2_1", id = "MM02_01_bink", display_name = "Hack the Planet: Intro" },
		{ mission = "r_leap01", id = "R_LEAP01_bink", display_name = "Platforming Rift: Intro" },
		{ mission = "m05", id = "M05_bink", display_name = "Power Up CID: Intro" },
		{ mission = "_a_gt_nw_01", id = "genki_tk", display_name = "Genki M.O.M.: Intro" },
		{ mission = "m06", id = "06_in", display_name = "Miller-Space: Intro 1" },
		{ mission = "m06", id = "M06_Matt_Flashback_bink", display_name = "Miller-Space: Intro 2" },
		{ mission = "m06", id = "06_Out", display_name = "Miller-Space: Outro" },
		{ mission = "m07", id = "07_in", display_name = "Matt's Back: Intro" },
		{ mission = "m07", id = "07_out", display_name = "Matt's Back: Outro" },
		{ mission = "_a_fc_test", id = "MM04_01_spfc_bink", display_name = "Fight Club: Intro" },
		{ mission = "m08", id = "08_In", display_name = "De Plane Boss: Intro 1" },
		{ mission = "m08", id = "M08_Shaundi_Flashback_bink", display_name = "De Plane Boss: Intro 2" },
		{ mission = "m08", id = "08_Out", display_name = "De Plane Boss: Outro" },
		{ mission = "m09", id = "09_in", display_name = "The Saints Flow: Intro 1" },
		{ mission = "m09", id = "M09_Pierce_Flashback_Bink", display_name = "The Saints Flow: Intro 2" },
		{ mission = "m09", id = "09_out", display_name = "The Saints Flow: Outro" },
		{ mission = "m10", id = "10_In", display_name = "King Me: Intro 1" },
		{ mission = "m10", id = "m10_ben_king_flashback", display_name = "King Me: Intro 2" },
		{ mission = "m10", id = "10_out", display_name = "King Me: Outro" },
		{ mission = "m11", id = "M11_Asha_Flashback_bink", display_name = "The Case of Mr. X: Intro 1" },
		{ mission = "m11", id = "11_In", display_name = "The Case of Mr. X: Intro 2" },
		{ mission = "m15_1", id = "15_In", display_name = "Welcome Back (Saints of Rage): Intro 1" },
		{ mission = "m15_1", id = "m15_gat_flashback_bink", display_name = "Welcome Back (Saints of Rage): Intro 2" },
		{ mission = "m15_3", id = "15_m_2", display_name = "Welcome Back (Mech Suit): Intro" },
		{ mission = "m15_3", id = "15_out", display_name = "Welcome Back (Mech Suit): Outro" },
		{ mission = "m16", id = "16_In", display_name = "When A Plan Comes Together: Intro" },
		{ mission = "m17", id = "17_In", display_name = "All Hands on Deck: Intro" },
		{ mission = "m17", id = "17_Out", display_name = "All Hands on Deck: Outro" },
		{ mission = "m18", id = "18_In", display_name = "He Lives: Intro" },
		{ mission = "m18", id = "18_m_1", display_name = "He Lives: Office" },
		{ mission = "m18", id = "18_out", display_name = "He Lives: Outro" },
		{ mission = "m19", id = "19_out", display_name = "Hello Teacup: Outro" },
		{ mission = "m20", id = "m20_bink", display_name = "We have the Technology: Intro" },
		{ mission = "m21", id = "m21_bink", display_name = "Batteries Not Included: Intro" },
		{ mission = "m22_1", id = "22_M_1", display_name = "Grand Finale: Intro" },
		{ mission = "m22_1", id = "M22_bink", display_name = "Grand Finale: Brief" },
		{ mission = "m22_2", id = "22_M_1_GatKng", display_name = "Grand Finale Part Two: Intro Gat & King" },
		{ mission = "m22_2", id = "22_M_1_ShnPrc", display_name = "Grand Finale Part Two: Intro Shaundi & Pierce" },
		{ mission = "m22_2", id = "22_M_1_AshMat", display_name = "Grand Finale Part Two: Intro Asha & Matt" },
		{ mission = "m22_3", id = "22_M_2", display_name = "Grand Finale Part Three: Intro" },
		{ mission = "m23", id = "23_In", display_name = "Grand Finale Part Four: Intro" },
		{ mission = "m23", id = "ending1_noloyal", display_name = "Grand Finale Part Four: Normal Ending" },
		{ mission = "m23", id = "ending2_loyal", display_name = "Grand Finale Part Four: True Ending" },
		{ mission = "m23", id = "Soultrain", display_name = "Grand Finale Part Four: This Is How We Do It" },
		{ mission = "m23", id = "Coda", display_name = "Grand Finale Part Four: True Ending Post-Credits" },
		{ mission = "mol_mm_01", id = "mol_mm01_bink", display_name = "Nytefall: Intro" },
		{ mission = "mol_sh01", id = "mol_sh01_bink", display_name = "Psychosomatic: Intro" },
		{ mission = "mol_p01", id = "mol_p01_bink", display_name = "Brotherhood: Intro" },
		{ mission = "mol_bk_01", id = "MOL_BK01_bink", display_name = "Dancing Queen: Intro" },
		{ mission = "mol_jb_01", id = "mol_jb01_bink", display_name = "Asha's VIP: Intro" },
		{ mission = "mol_jg_01", id = "mol_jg01_bink", display_name = "Gat Time, Fun Time: Intro" },
		{ mission = "mol_kz_01", id = "MOL_KZ01_bink", display_name = "Kinzie's Adventures: Intro" },
		{ mission = "r_speed01", id = "R_SPEED01_bink", display_name = "Speed Rift: Intro" },
		{ mission = "r_tk01", id = "R_TK01_bink", display_name = "Telekinesis Rift: Intro" },

		{ mission = "m23", id = "22_M_1_slomo", display_name = "UNUSED: 22_M_1_slomo" },
		{ mission = "m23", id = "wormhole", display_name = "UNUSED: wormhole" },
		--{ mission = "m23", id = "Zinyakstar", display_name = "UNUSED: Zinyakstar" },
		--{ mission = "m23", id = "mm_5_1_bink", display_name = "UNUSED: mm_5_1_bink" },

		{ mission = "dlc1_m01", id = "dlc1_01_in", display_name = "Save the Planet: Intro" },
		{ mission = "dlc1_m01", id = "dlc1_01_mid_bink", display_name = "Save the Planet: Nyte Blayde" },
		{ mission = "dlc1_m02", id = "dlc1_02_in", display_name = "Meet the Dominatrix: Intro" },
		{ mission = "dlc1_m03", id = "dlc1_03_in", display_name = "At the Races: Intro" },
		{ mission = "dlc1_m04", id = "dlc1_04_in", display_name = "Pop his Top: Intro" },
		{ mission = "dlc1_m04", id = "dlc1_04_out_bink", display_name = "Pop his Top: Outro" },
		{ mission = "dlc1_m05", id = "dlc1_05_in", display_name = "Escape the Dominatrix: Intro" },
		{ mission = "dlc1_m05", id = "dlc1_05_mid_bink", display_name = "Escape the Dominatrix: Outro 1" },
		{ mission = "dlc1_m05", id = "dlc1_05_out_bink", display_name = "Escape the Dominatrix: Outro 2" },

		{ mission = "dlc2_m01", id = "dlc2_in", display_name = "Miracle on 3rd Street: Intro" },
		{ mission = "dlc2_m02", id = "dlc2_m02_bink", display_name = "The Fight Before Christmas: Intro" },
		{ mission = "dlc2_m03", id = "dlc2_m03_bink", display_name = "The Santa Clawz: Intro" },
		{ mission = "dlc2_m03", id = "dlc2_01_out", display_name = "The Santa Clawz: Outro" },
		{ mission = "dlc2_a_gh_nw_01", id = "dlc2_genki_bink", display_name = "Genki Holiday Special: Intro" },
	},
	[CTV_SRGOOH] = {
		{ mission = "mIntro", id = "intro", display_name = "Go to Hell: Intro" },
		{ mission = "mIntro", id = "Bink_MeetDane", display_name = "Go to Hell: Outro" },
		{ mission = "mFlightTutorial", id = "Bink_Intro_Hell", display_name = "Spread your Wings: Outro" },
		{ mission = "mIntroBB", id = "Bink_Blackbeard_Aided", display_name = "Collect the Summons Power: Outro" },
		{ mission = "mIntroShakes", id = "Bink_Shakespeare_Confronted", display_name = "Collect the Stomp Power: Outro" },
		{ mission = "mIntroTwins", id = "Bink_Twins_Aided", display_name = "Collect the Blast Power: Outro" },
		{ mission = "mIntroVlad", id = "Bink_Vlad_Rescued", display_name = "Collect the Aura Power: Outro" },

		{ mission = "mIntro", id = "Bink_Mayhem", display_name = "Mayhem: Intro" },
		{ mission = "mIntro", id = "Bink_Torment_Fraud", display_name = "Torment Fraud: Intro" },
		{ mission = "mIntro", id = "Bink_Hellblazing", display_name = "Hellblazing: Intro" },
		{ mission = "mIntro", id = "Bink_Salvation", display_name = "Salvation: Intro" },
		{ mission = "mIntro", id = "Bink_Survival", display_name = "Survival: Intro" },
		{ mission = "mIntro", id = "Bink_Altar", display_name = "Altar: Intro" },
		{ mission = "mIntro", id = "Bink_Marshaling_Ground", display_name = "Marshaling Ground: Intro" },
		{ mission = "mIntro", id = "Bink_Extraction_Facility", display_name = "Extraction: Intro" },
		{ mission = "mIntro", id = "Bink_Pledge_Rush", display_name = "Pledge Rush: Intro" },
		{ mission = "mIntro", id = "bink_glyph", display_name = "Glyph and Chest: Intro" },
		
		-- get_player_respect() always returns 0 in SRGOOH :(
		{ mission = "mSatan", id = "Bink_Musical", display_name = "XP Level 5: Musical" },
		{ mission = "mSatan", id = "Bink_Spire", display_name = "XP Level 5: Spire" },
		{ mission = "mSatan", id = "bink_MeetJezebel", display_name = "XP Level 10: Meet Jezebel" },
		{ mission = "mSatan", id = "bink_FacePalm", display_name = "XP Level 15: Enter Palace" },

		{ mission = "mSatan", id = "mSatan", play_mission_cancel_quickly = true, display_name = "Crash the Wedding: Intro" },
		{ mission = "mSatan", id = "Satan_punch_out", display_name = "Crash the Wedding: Face Punch (No Audio)" },
		{ mission = "mSatan", id = "outro", display_name = "Crash the Wedding: Outro" },

		{ mission = "mSatan", id = "Bink_Alt_Heaven", display_name = "Crash the Wedding: Reunite with Aisha" },
		{ mission = "mSatan", id = "Bink_Alt_Hell", display_name = "Crash the Wedding: New King of Hell" },
		{ mission = "mSatan", id = "Bink_Alt_New_Planet", display_name = "Crash the Wedding: New Home World" },
		{ mission = "mSatan", id = "Bink_Alt_New_Earth", display_name = "Crash the Wedding: Retcon the entire world" },
		{ mission = "mSatan", id = "Bink_Alt_Cosmic", display_name = "Crash the Wedding: Answers to all the questions of the universe" },

		{ mission = "mSatanFlight", id = "Bink_Forge_Island", display_name = "100%% Takeover: Forge" },
		{ mission = "mSatanFlight", id = "Bink_Shantytown_Island", display_name = "100%% Takeover: Shantytown" },
		{ mission = "mSatanFlight", id = "Bink_Barrens_Island", display_name = "100%% Takeover: Barrens" },
		{ mission = "mSatanFlight", id = "Bink_Entertainment_Island", display_name = "100%% Takeover: Den" },
		{ mission = "mSatanFlight", id = "Bink_Downtown_Island", display_name = "100%% Takeover: Downtown" },
		{ mission = "mSatanFlight", id = "Bink_Islands_Completed", display_name = "Shawarma" },

		{ mission = "mSatan", id = "Bink_Drained", display_name = "UNUSED: Drained" },
		{ mission = "mSatan", id = "end_select", display_name = "UNUSED: end_select" },

		-- These NO AUDIO cutscenes are probably used internally from their respective Bink versions
		{ mission = "mSatan", id = "Meet_Dane", display_name = "NO AUDIO: Go to Hell Outro" },
		{ mission = "mSatan", id = "Musical", display_name = "NO AUDIO: Musical" },
		{ mission = "mSatan", id = "meet_jezebel", display_name = "NO AUDIO: Meet Jezebel" },
		{ mission = "mSatan", id = "face_palm", display_name = "NO AUDIO: Enter Palace" },
		{ mission = "mSatan", id = "Wedding_Party", display_name = "NO AUDIO: Crash the Wedding Intro" },
		{ mission = "mSatan", id = "void_outro", display_name = "NO AUDIO: Talking with God" },
		{ mission = "mSatan", id = "alt_heaven", display_name = "NO AUDIO: Reunite with Aisha" },
		{ mission = "mSatan", id = "alt_hell", display_name = "NO AUDIO: New King of Hell" },
		{ mission = "mSatan", id = "alt_new_planet", display_name = "NO AUDIO: New Home World" },
		{ mission = "mSatan", id = "alt_new_earth", display_name = "NO AUDIO: Retcon the entire world" },
		{ mission = "mSatan", id = "alt_cosmic", display_name = "NO AUDIO: Answers to all the questions of the universe" },

	}
}

-- TV Locations
CTV_TV_LOCATIONS = {
	[CTV_SRTT] = {
		{x = 1266.5290527344, y = 30.753562927246, z = 105.0544128418, dist = 1.5, crib = "Crib_Shaundis_Ex"},
		{x = 112.37329864502, y = 145.74664306641, z = 1067.2487792969, dist = 3, crib = "Crib_SaintsHQ"},
		{x = 808.71710205078, y = 10.38115978241, z = 1037.4451904297, dist = 2, crib = "Crib_Angels"},
		{x = 2098.8049316406, y = 9.1232166290283, z = -273.39474487305, dist = 3, crib = "Crib_Kinzie"},
		{x = 2110.6435546875, y = 9.1263341903687, z = -265.24728393555, dist = 3, crib = "Crib_Kinzie"},
		{x = -1250.2465820313, y = 13.71316242218, z = 157.65757751465, dist = 3, crib = "Crib_Zimos"},
		{x = -1186.0247802734, y = 87.601860046387, z = -567.5146484375, dist = 3, crib = "Crib_BDSM"},
		{x = 1328.0720214844, y = 193.73417663574, z = -1196.7679443359, dist = 3, crib = "Crib_Nuke"},
		{x = 1187.1151123047, y = 227.45120239258, z = 1439.1072998047, dist = 3, crib = "Crib_3Count"},
	},
	[CTV_SRIV] = {
		-- Kinzie's Warehouse
		{x = 2098.8049316406, y = 9.1232166290283, z = -273.39474487305, dist = 3},
		-- Saints HQ (The Saints Flow; Need Other Mods)
		{x = -1462.79, y = 145.75, z = 1083.01, dist = 3},
		-- 3 Count (DLC; Need Other Mods)
		{x = 1187.1151123047, y = 227.45120239258, z = 1439.1072998047, dist = 3},
	},
	[CTV_SRGOOH] = {
		-- Armchair
		{x = 1020.6683959961, y = 5.6260676383792, z = -580.71740722656, dist = 1.2},
	}
}

-- E key prompt text
CTV_PROMPT_TEXT = {
	[CTV_SRTT] = "CUTSCENE_TITLE_DEFAULT",
	[CTV_SRIV] = "MENU_TITLE_CONFIRM",
	[CTV_SRGOOH] = "MENU_TITLE_CONFIRM",
}

-- Previous Buttons
CTV_PREV_BUTTONS = {
	"CBA_VDC_PREV_RADIO",
	"CBA_OFC_TAUNT_TWO",
	"CBA_GAC_WEAPON_SELECT_1",
	"CBA_OFC_CROUCH",
	"CBA_OFC_CROUCH_TOGGLE",
}
-- Next Buttons
CTV_NEXT_BUTTONS = {
	"CBA_VDC_NEXT_RADIO",
	"CBA_OFC_TAUNT_THREE",
	"CBA_GAC_WEAPON_SELECT_2",
	"CBA_OFC_PICKUP_RELOAD",
}

Ctv_game = CTV_SRTT	-- Which game we're running?
Ctv_cutscene_list = {}	-- Selectable cutscene list
Ctv_prompt_active = false	-- Prompt currently visible
Ctv_prompt_triggered = false	-- Player has pushed their E key
Ctv_selected_cutscene = 1	-- Selected cutscene number
Ctv_message_handle = -1	-- Last message handle

-- Main Thread
-- Run it by `thread_new("ctv_main_thread")` from sr3_city_main()
function ctv_main_thread()
	-- Find out which game we're playing
	if MAX_NOTORIETY_LEVEL == 5 then
		-- If max notoriety is 5, we're in SRTT
		Ctv_game = CTV_SRTT
	elseif MAX_NOTORIETY_LEVEL == 6 then
		-- If max notoriety is 6...
		Ctv_game = CTV_SRIV	-- Assume SRIV by default
		
		-- If there is a function named "extraction_reset" then we're in SRGOOH
		for func, v in pairs(_G) do
			if func == "extraction_reset" then
				Ctv_game = CTV_SRGOOH
				break
			end
		end
	end

	-- Wait until the loading screen goes away
	fade_in_block()

	-- Wait until the player completes the prologue
	if ctv_srtt() then
		while (not mission_is_complete("m03")) or mission_is_active() do
			thread_yield()
		end
	elseif ctv_sriv() then
		while (not mission_is_complete("mm_1_1")) or mission_is_active() do
			thread_yield()
		end
	elseif ctv_srgooh() then
		while (not mission_is_complete("mFlightTutorial")) or mission_is_active() do
			thread_yield()
		end
	end

	ctv_populate_cutscenes()

	local show_message = false

	--ctv_teleport_human(LOCAL_PLAYER, 2098.8049316406, 9.1232166290283, -273.39474487305)

	while true do
		thread_yield()

		-- If a mission becomes active
		if mission_is_active() or (not cutscene_play_check_done()) then
			-- Clear markers
			ctv_clear_prompt()

			-- Wait until the mission ends
			while mission_is_active() or (not cutscene_play_check_done()) do
				thread_yield()
			end

			-- Repopulate Cutscene List (so when a new mission is completed, new cutscenes are unlocked)
			ctv_populate_cutscenes()
		end
		
		-- Check if the player is near a TV
		local player_is_on_marker = false
		for i, tv in pairs(CTV_TV_LOCATIONS[ctv_get_game()]) do
			local unlocked = true
			if (tv.crib ~= nil) and (not crib_is_unlocked(tv.crib)) then
				unlocked = false
			end
			
			if unlocked and ctv_is_close_enough(LOCAL_PLAYER, tv.x, tv.y, tv.z, tv.dist) then
				player_is_on_marker = true
				break
			end
		end
		
		-- Add/Remove Prompt
		if player_is_on_marker then
			if ctv_add_prompt() then
				-- If a prompt just became active, show messages
				show_message = true
			end
		else
			if ctv_clear_prompt() then
				-- If the player just left the marker, erase messages
				message_remove(Ctv_message_handle, false)
				Ctv_message_handle = -1
			end
		end
		
		-- Handle prev/next buttons
		if player_is_on_marker then
			if ctv_is_prev_button_pressed() then
				audio_object_post_event("UI_STAG_PROTOTYPE_SCROLL", nil, nil, LOCAL_PLAYER)
				Ctv_selected_cutscene = Ctv_selected_cutscene - 1
				if Ctv_selected_cutscene < 1 then
					Ctv_selected_cutscene = #Ctv_cutscene_list
				end
				show_message = true
			elseif ctv_is_next_button_pressed() then
				audio_object_post_event("UI_STAG_PROTOTYPE_SCROLL", nil, nil, LOCAL_PLAYER)
				Ctv_selected_cutscene = Ctv_selected_cutscene + 1
				if Ctv_selected_cutscene > #Ctv_cutscene_list then
					Ctv_selected_cutscene = 1
				end
				show_message = true
			end
		end
		
		if show_message then
			show_message = false
			
			local cutscene = Ctv_cutscene_list[Ctv_selected_cutscene]
			
			message_remove(Ctv_message_handle, false)
			
			if ctv_srgooh() then
				Ctv_message_handle = message("CUTSCENE TV\n{CROUCH_IMG}/{PICKUP_RELOAD_IMG} CHOOSE\n\n"..cutscene.display_name.."\n("..Ctv_selected_cutscene.."/"..#Ctv_cutscene_list..")", 5, false, SYNC_LOCAL)
			else
				Ctv_message_handle = message("CUTSCENE TV\n{AUDIO_PLAYER_PREV_TRACK_IMG}/{AUDIO_PLAYER_NEXT_TRACK_IMG} CHOOSE\n\n"..cutscene.display_name.."\n("..Ctv_selected_cutscene.."/"..#Ctv_cutscene_list..")", 5, false, SYNC_LOCAL)
			end
		end

		-- E key pushed
		if Ctv_prompt_triggered then
			Ctv_prompt_triggered = false
			ctv_clear_prompt()
			message_remove(Ctv_message_handle, false)
			audio_object_post_event("UI_HUD_SURVIVAL_WAVE_START", nil, nil, LOCAL_PLAYER)

			-- Remember the current player positions
			local p1_x, p1_y, p1_z = get_object_pos(LOCAL_PLAYER)
			local p2_x, p2_y, p2_z = 0, 0, 0
			if coop_is_active() then
				p2_x, p2_y, p2_z = get_object_pos(REMOTE_PLAYER)
			end

			local cutscene = Ctv_cutscene_list[Ctv_selected_cutscene]
			local id = cutscene.id

			-- Zone Swaps
			if (cutscene.zones_to_false ~= nil) then
				if type(cutscene.zones_to_false) == "table" then
					for i, zone in pairs(cutscene.zones_to_false) do
						debug_print("Swapping zone "..zone.." to false\n")
						city_zone_swap(zone, false)
					end
				elseif type(cutscene.zones_to_false) == "string" then
					city_zone_swap(cutscene.zones_to_false, false)
				end
			end
			if (cutscene.zones_to_true ~= nil) then
				if type(cutscene.zones_to_true) == "table" then
					for i, zone in pairs(cutscene.zones_to_true) do
						debug_print("Swapping zone "..zone.." to true\n")
						city_zone_swap(zone, true)
					end
				elseif type(cutscene.zones_to_true) == "string" then
					city_zone_swap(cutscene.zones_to_true, true)
				end
			end

			local restore_player_positions = true
			
			if cutscene.activity then
				-- Activities
				debug_print("Starting Activity Intro: " .. id .. "\n")
				if not ctv_srgooh() then
					sr3_teleport_mission_start(id, false)
				end
				mission_set_next_mission(id)
				
				-- Wait until the activity is active
				debug_print("Waiting for activity "..cutscene.activity.." to begin\n")
				while not mission_is_active(cutscene.activity) do
					thread_yield()
				end
				
				debug_print("Waiting for activity "..cutscene.activity.." to end\n")
				while mission_is_active(cutscene.activity) do
					thread_yield()
				end
				
				debug_print("Waiting for fade in\n")
				fade_in_block()
				
				debug_print("Activity "..cutscene.activity.." ended\n")
			elseif cutscene.play_phonecall then
				-- Phonecall
				debug_print("Starting Phonecall: " .. id .. "\n")
				mission_set_next_mission(id)
				restore_player_positions = false
				
				-- Wait until the mission is active
				debug_print("Waiting for phonecall "..id.." to begin\n")
				while not mission_is_active(id) do
					thread_yield()
				end
				
				debug_print("Phonecall "..id.." is now active\n")
				
				-- Wait until the mission ends
				debug_print("Waiting for phonecall "..id.." to end\n")
				while mission_is_active(id) do
					thread_yield()
				end
				
				debug_print("Phonecall "..id.." ended\n")
			elseif cutscene.play_mission then
				-- Cutscene-only Mission
				debug_print("Starting Cutscene-only Mission: " .. id .. "\n")
				if not ctv_srgooh() then
					sr3_teleport_mission_start(id, false)
				end
				mission_set_next_mission(id)
				
				-- Wait until the mission is active
				debug_print("Waiting for mission "..id.." to begin\n")
				while not mission_is_active(id) do
					thread_yield()
				end
				
				debug_print("Mission "..id.." is now active\n")
				
				-- Wait until the mission ends
				debug_print("Waiting for mission "..id.." to end\n")
				while mission_is_active(id) do
					thread_yield()
				end
				
				debug_print("Mission "..id.." ended\n")
			elseif cutscene.play_mission_cancel_quickly then
				-- Mission (cancel quickly)
				debug_print("Starting Mission (will cancel quickly): " .. id .. "\n")
				if not ctv_srgooh() then
					sr3_teleport_mission_start(id, false)
				end
				mission_set_next_mission(id)
				
				-- Wait until the mission plays a cutscene
				debug_print("Waiting for mission "..id.." to play a cutscene\n")
				while cutscene_play_check_done() do
					thread_yield()
				end

				-- Wait until the cutscene ends
				debug_print("Waiting for mission "..id.."'s cutscene ends\n")
				while not cutscene_play_check_done() do
					thread_yield()
				end
				
				-- Request mission cancel
				mission_end_silently(false)
				
				-- Wait until the mission ends
				debug_print("Waiting for mission "..id.." to end\n")
				while mission_is_active(id) do
					thread_yield()
				end
				
				debug_print("Mission "..id.." ended\n")
			else
				-- Normal Cutscene
				debug_print("Starting Cutscene: " .. id .. "\n")

				-- name = id
				-- group_name = nil
				-- teleport_name = nil
				-- fade_in_after = true
				-- wait_for_spawning = true
				cutscene_play(id, nil, nil, true, true)

				-- When cutscene is finished
				debug_print("Cutscene Finished: " .. id .. "\n")
			end
			
			-- Restore Nuke and 3 Count cribs to Saints
			if ctv_srtt() then
				if mission_is_complete("sh03") then
					city_zone_swap("nuke1", true)
					city_zone_swap("nuke2", true)
					city_zone_swap("int_sh03", true)
					city_zone_swap("int_sh03c", true)
				end
				if mission_is_complete("sh04") then
					city_zone_swap("3count1", true)
					city_zone_swap("3count2", true)
					city_zone_swap("int3cc", true)
				end
			end
			
			-- Playing 22_M_1_slomo (UNUSED) activates ASCII mode, so disable it
			if ctv_sriv() then
				enable_ascii_mode(false)
			end
			
			-- Teleport players to their original locations
			if restore_player_positions then
				ctv_teleport_human(LOCAL_PLAYER, p1_x, p1_y, p1_z)
				if coop_is_active() then
					ctv_teleport_human(REMOTE_PLAYER, p2_x, p2_y, p2_z)
				end
				ctv_add_prompt()
				show_message = true
			end
		end
	end
end

function ctv_populate_cutscenes()
	Ctv_cutscene_list = {}
	for i, cutscene in pairs(CTV_CUTSCENES[ctv_get_game()]) do
		if mission_is_complete(cutscene.mission) then
			Ctv_cutscene_list[#Ctv_cutscene_list + 1] = cutscene
		end
	end
	--debug_print("Cutscenes available for play:" .. #Ctv_cutscene_list .. "\n")
end

-- Add prompt
function ctv_add_prompt()
	if not Ctv_prompt_active then
		--debug_print("Prompt Added\n")

		hud_prompt(LOCAL_PLAYER, CTV_PROMPT_TEXT[ctv_get_game()], "ctv_prompt_triggered_cb")
		if ctv_srtt() then
			crib_disable_interface(true)	-- While the prompt is active, disallow crib menu
		end

		Ctv_prompt_active = true
		return true
	end
	return false
end

-- Clear prompt
function ctv_clear_prompt()
	if Ctv_prompt_active then
		--debug_print("Prompt Removed\n")

		hud_prompt_clear(LOCAL_PLAYER)
		if ctv_srtt() then
			crib_disable_interface(false)
		end

		Ctv_prompt_active = false
		return true
	end
	return false
end

-- Prompt triggered
function ctv_prompt_triggered_cb()
	Ctv_prompt_triggered = true
end

-- Prev button pressed
function ctv_is_prev_button_pressed()
	for i, action in pairs(CTV_PREV_BUTTONS) do
		if player_action_just_pressed(action) then
			return true
		end
	end
	return false
end

-- Next button pressed
function ctv_is_next_button_pressed()
	for i, action in pairs(CTV_NEXT_BUTTONS) do
		if player_action_just_pressed(action) then
			return true
		end
	end
	return false
end

-- Returns true on SRTT
function ctv_srtt()
	return (Ctv_game == CTV_SRTT)
end

-- Returns true on SRIV
function ctv_sriv()
	return (Ctv_game == CTV_SRIV)
end

-- Returns true on SRGOOH
function ctv_srgooh()
	return (Ctv_game == CTV_SRGOOH)
end

-- Get current game (CTV_SRTT, CTV_SRIV, or CTV_SRGOOH)
function ctv_get_game()
	return Ctv_game
end

-- Check if the specified object is close enough to the specified location
function ctv_is_close_enough(obj, x, y, z, dist)
	local px, py, pz = get_object_pos(obj)
	local dx = px - x
	local dy = py - y
	local dz = pz - z
	if dx < 0 then
		dx = -dx
	end
	if dy < 0 then
		dy = -dy
	end
	if dz < 0 then
		dz = -dz
	end
	if (dx < dist) and (dy < dist) and (dz < dist) then
		return true
	end
	return false
end

-- Teleport a human to the specified location
function ctv_teleport_human(human, x, y, z)
	-- Used for custom teleports
	local stele_Posx = 431.295288085938
	local stele_Posy = 8.0703125
	local stele_Posz = 936.460083007812
	local obj_name = "Dock_Purchase"
	if ctv_sriv() then
		-- Teleport for SRIV
		stele_Posx = 1361.86633300781
		stele_Posy = 33.0730209350586
		stele_Posz = -818.10595703125
		obj_name = "nw_qm_nav"
	elseif ctv_srgooh() then
		-- Teleport for SRGOOH
		stele_Posx = -358.60131835938
		stele_Posy = 0.12552392482758
		stele_Posz = -224.81632995605
		obj_name = "mIntroBB"
	end
	local exit_vehicle = true
	local reset_camera_orient = false
	local offset_in_local_spc = false
	local force_to_navmesh = false
	local heading_offset = 0.0
	local navmesh_hint_obj = obj_name
	teleport_to_object(human, obj_name, exit_vehicle, reset_camera_orient, x - stele_Posx, y - stele_Posy, z - stele_Posz, offset_in_local_spc, heading_offset, force_to_navmesh, navmesh_hint_obj)
end
